/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2016, 2017 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_tau_user.c
* Version      : Code Generator for RL78/G11 V1.01.00.03 [15 May 2017]
* Device(s)    : R5F1058A
* Tool-Chain   : CCRL
* Description  : This file implements device driver for TAU module.
* Creation Date: 2018/05/10
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_tau.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
#pragma interrupt r_tau0_channel0_interrupt(vect=INTTM00)
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
uint8_t	counter = 0x00;			/* LED̓_p^[p()	*/

/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: r_tau0_channel0_interrupt
* Description  : This function INTTM00 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_tau0_channel0_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
    uint8_t work;			/* LED1`LED7̓_p	*/
    uint8_t work2;			/* LED8`LED14̓_p	*/
    
    work = counter ^ 0xFF;		/* LED_i0œ_j̈	*/
    if ( ( counter & 0x80 ) )
    {
	    work2 = counter;
    }
    else
    {
	    work2 = counter ^ 0xFF;
    }
    
    P0_bit.no0 = ( work & 0x0001 ); work = ( work >> 1 );	/* LED1	*/
    P0_bit.no1 = ( work & 0x0001 ); work = ( work >> 1 );	/* LED2	*/
    P2_bit.no0 = ( work & 0x0001 ); work = ( work >> 1 );	/* LED3	*/
    P2_bit.no1 = ( work & 0x0001 ); work = ( work >> 1 );	/* LED4	*/
    P2_bit.no2 = ( work & 0x0001 ); work = ( work >> 1 );	/* LED5	*/
    P5_bit.no6 = ( work & 0x0001 ); work = ( work >> 1 );	/* LED6	*/
    P3_bit.no3 = ( work & 0x0001 ); work = ( work >> 1 );	/* LED7	*/
    
    P2_bit.no3 = ( work2 & 0x0001 ); work2 = ( work2 >> 1 );	/* LED14	*/
    P5_bit.no4 = ( work2 & 0x0001 ); work2 = ( work2 >> 1 );	/* LED13	*/
    P5_bit.no3 = ( work2 & 0x0001 ); work2 = ( work2 >> 1 );	/* LED12	*/
    P5_bit.no2 = ( work2 & 0x0001 ); work2 = ( work2 >> 1 );	/* LED11	*/
    P5_bit.no1 = ( work2 & 0x0001 ); work2 = ( work2 >> 1 );	/* LED10	*/
    P3_bit.no2 = ( work2 & 0x0001 ); work2 = ( work2 >> 1 );	/* LED9	*/
    P3_bit.no1 = ( work2 & 0x0001 ); work2 = ( work2 >> 1 );	/* LED8	*/
    

    
    P3_bit.no0 = P12_bit.no2;
    P5_bit.no5 = P13_bit.no7;

    counter++;

    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
